
#include "sound.h"
#include "utils.h"



void scale(void)
{
  unsigned int note[] = 
    { 
	440, // A	la
	466, // A#	la#
	494, // B	si
	523, // C	do
	554, // C#	do#
	582, // D	re
	622, // D#	re#
	659, // E	mi
	698, // F	fa
	743, // F#	fa#
	787, // G	sol
	827  // G#	sol#
    };
  unsigned char n;


  for (n=0; n<12 ; n++)
    {
       sound(note[n]*2, 150);// 2nd overtone music notes (150 ms each)
    }
    
}


void beep(unsigned int t)		// buzzer on PD7; duration=t*250us (4000=1s)
{
  unsigned int i;
  unsigned char j,k;
  for (i=0;i<t;i++) {			// 126us*2= 252us period (4KHz)
    sbi(PORTD,7);
    for (j=0;j<2;j++)			// (500+4)*2=1008 *125ns=126us
      for (k=0;k<100;k++) asm("nop");	// (4+1)cycles*100=500
    cbi(PORTD,7);
    for (j=0;j<2;j++)
      for (k=0;k<100;k++) asm("nop");
  }
}

void sound(unsigned int hz, unsigned int msecs)
{
  unsigned int n, i, j, k;
  k = (400000 / hz);	// k = (n. of cpu cycles in each tone period) / 2
  n = (int)(((long)msecs * (long)hz)/1000);
  for (i=0;i<n;i++) {
    sbi(PORTD,7);
    for (j=0;j<k;j++) {
       asm("nop");	// delay = (6+4)cycles * k * 125us
       asm("nop");
       asm("nop");
       asm("nop");
    }		
    cbi(PORTD,7);
    for (j=0;j<k;j++) {
       asm("nop");	// delay = (6+4)cycles * k * 125us 
       asm("nop");
       asm("nop");
       asm("nop");
    }    
  }
}



void song (void)
{
  sound(B,200);
  sound(B,200);
  sound(C,400);
  sound(B,400);
  sound(G,400);
  sound(D,200);
  sound(E,200);
  sound(A,200);
  sound(G,200);
  sound(F*2,200);
  sound(F,400);
  sound(G,400);
  sound(A,400);
  sound(D,400);
  delay(600/5);
  sound(F,400);
  sound(G,400);
  sound(G2,400);
  sound(D,400);
  sound(D*2,200);
  sound(C,200);
  sound(B,200);
  sound(A,200);
  sound(G2,200);
  sound(A,200);
  sound(B,400);
  delay(200/5);
  sound(B,200);
  sound(G,200);
  sound(E,200);
  delay(200/5);
  sound(B,200);
  sound(G,200);
  sound(D,200);
  sound(A,200);
  sound(G,200);
}
